import { createElement as _createElement } from "react";
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import Autocomplete from "@mui/material/Autocomplete";
import TextField from "@mui/material/TextField";
import React, { useState } from "react";
import Paper from "@mui/material/Paper";
import { PaperComponentOnLoad } from "./paperComponentOnLoad";
import { RenderTemplate } from "./renderTemplate";
import { ConditionalWrapper } from "../utility/conditionalWrapper";
import Grid from "@mui/material/Grid";
import IconButton from "@mui/material/IconButton";
import EditIcon from "@mui/icons-material/Edit";
import CloseIcon from "@mui/icons-material/Close";
import { nanoid } from "@reduxjs/toolkit";
import { AutocompleteType, InputAux } from "../nerdInput/nerdInputEnums";
export const NerdAutoComplete = ({ itemID, value, fullWidth, onChange, onInputChange, inputValue, label, placeholder, options = [], variant = "standard", required = false, helperText, loading, autocompleteType = AutocompleteType.CUSTOMER, icon, spacing = 1, alignItems = "center", disabled = false, 
//inputSize = 6,
autoCompleteOptionLabel = "", className, isEditable = false, }) => {
    const [open, setOpen] = useState(false);
    // const sizeWithIcons = fullWidth ? 11 : inputSize;
    //const customInputSize = fullWidth && !icon ? 12 : sizeWithIcons;
    return (_jsx(ConditionalWrapper, { condition: icon !== undefined, wrapper: (childrenContent) => (_jsx(Grid, { container: true, spacing: spacing, alignItems: alignItems, children: childrenContent })), children: _jsxs(React.Fragment, { children: [icon && _jsx(Grid, { item: true, children: icon }), _jsx(Grid, { item: true, sm: true, children: _jsx(Autocomplete, { id: itemID, open: open, value: value, fullWidth: fullWidth, onOpen: () => setOpen(true), onClose: () => setOpen(false), onChange: onChange, onInputChange: onInputChange, inputValue: inputValue, options: options, clearIcon: null, getOptionLabel: (option) => getOptionLabel(option, autoCompleteOptionLabel), onKeyDown: (event) => {
                            if (event.key === "Enter") {
                                // Prevent's default 'Enter' behavior.
                                event.preventDefault();
                                // handler code
                            }
                        }, renderInput: (params) => (_jsx(TextField, { ...params, label: label, variant: variant, placeholder: placeholder, InputLabelProps: {
                                shrink: true,
                            }, InputProps: {
                                ...params.InputProps,
                                endAdornment: null,
                            }, helperText: renderHelperText(required, helperText), required: required, fullWidth: true })), renderOption: (props, option) => {
                            return (_jsx(RenderTemplate, { ...props, option: option, autocompleteType: autocompleteType, optionsArray: options }));
                        }, PaperComponent: (props) => {
                            if (!inputValue || loading) {
                                return (_createElement(PaperComponentOnLoad, { ...{ props, inputValue, autocompleteType, loading }, key: nanoid(), className: className ? "autocompleteSmall" : "" }));
                            }
                            return (_createElement(Paper, { ...props, key: nanoid(), className: className ? "autocompleteSmall" : "" }, props.children));
                        } }) }), icon && (_jsxs(Grid, { item: true, flexDirection: "column", display: "flex", children: [isEditable && (_jsx(IconButton, { disabled: disabled, size: "small", onClick: (event) => {
                                setOpen(false);
                                onChange(event, "");
                                onInputChange(event, "");
                            }, children: _jsx(EditIcon, { fontSize: "small" }) })), _jsx(IconButton, { disabled: disabled, size: "small", onClick: (event) => {
                                setOpen(false);
                                onChange(event, "");
                                onInputChange(event, "");
                            }, children: _jsx(CloseIcon, { fontSize: "small" }) })] }))] }) }));
};
/**
 *
 * @param required
 * @param helperText
 */
function renderHelperText(required, helperText) {
    if (!helperText) {
        return "";
    }
    return required ? InputAux.REQUIRED : helperText;
}
/**
 *
 * @param option
 * @param autoCompleteOptionLabel
 */
function getOptionLabel(option, autoCompleteOptionLabel) {
    if (typeof option === "string") {
        return option;
    }
    if (typeof option === "object" && Object.keys(option).length > 0) {
        return option[autoCompleteOptionLabel];
    }
    return "";
}
//# sourceMappingURL=nerdAutocomplete.js.map