import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import CircularProgress from "@mui/material/CircularProgress";
import ClickAwayListener from "@mui/material/ClickAwayListener";
import Grid from "@mui/material/Grid";
import Paper from "@mui/material/Paper";
import React from "react";
import PersonSearchIcon from "@mui/icons-material/PersonSearch";
import { NerdHeading } from "../nerdHeading";
import MapTwoToneIcon from "@mui/icons-material/MapTwoTone";
import { Divider, Stack, Typography } from "@mui/material";
import { uid } from "../utility/utils";
import { AutocompleteOnLoadHeading, AutocompleteType, } from "../nerdInput/nerdInputEnums";
/**
 * @param { React.HTMLAttributes<HTMLElement> } paperProps - Autocomplete props onLoad
 * @returns { React.ReactElement } - Render react Autocomplete component onLoad
 */
export function PaperComponentOnLoad(paperProps) {
    const { className, inputValue, loading, autocompleteType, ...other } = paperProps;
    return (_jsx(Paper, { ...other, className: className ? "autocompleteSmall" : "", children: _jsx(ClickAwayListener, { onClickAway: () => console.log("onClick"), children: _jsx(React.Fragment, { children: inputValue && loading ? (_jsxs(WrapperCustomerOnload, { children: [_jsx(CircularProgress, { color: "primary", size: 40 }), _jsx(NerdHeading, { text: "loading", variant: "h6" })] })) : (contentOnLoad(autocompleteType, inputValue, loading)) }) }) }));
}
const CustomerOnload = () => {
    return (_jsxs(WrapperCustomerOnload, { children: [_jsx(PersonSearchIcon, { fontSize: "large" }), _jsx(NerdHeading, { text: AutocompleteOnLoadHeading.CUSTOMER, variant: "h6" })] }));
};
const AdrressOnload = () => {
    return (_jsxs(React.Fragment, { children: [_jsxs(WrapperCustomerOnload, { children: [_jsx(MapTwoToneIcon, { fontSize: "large" }), _jsx(NerdHeading, { text: AutocompleteOnLoadHeading.ADDRESS, variant: "h6" })] }), _jsx(Divider, {}), _jsx(Grid, { container: true, alignItems: "center", justifyContent: "center", children: _jsx(Grid, { item: true, py: 1, children: _jsxs(Typography, { display: "block", variant: "caption", color: "textSecondary", children: ["Powered by ", _jsx("b", { children: "Google" }), " and ", _jsx("b", { children: "Archer" })] }) }) })] }));
};
const WrapperCustomerOnload = (props) => {
    return (_jsx(Stack, { direction: "column", justifyContent: "center", alignItems: "center", spacing: 2, py: 7, children: props.children }));
};
/**
 * @param {any} args - content onLoad args
 * @returns {void}
 */
function contentOnLoad(...args) {
    return args.map((arg, i) => {
        if (i === 0 && typeof arg === "string" && arg !== "") {
            switch (arg) {
                case AutocompleteType.CUSTOMER:
                    return _jsx(CustomerOnload, {}, uid());
                case AutocompleteType.ADDRESS:
                    return _jsx(AdrressOnload, {}, uid());
            }
        }
        return _jsx(React.Fragment, {}, uid());
    });
}
//# sourceMappingURL=paperComponentOnLoad.js.map