import { jsx as _jsx } from "react/jsx-runtime";
import { InputAdornment } from "@mui/material";
import NerdMaskField from "../nerdMaskField/nerdMaskField";
/**
 *
 * @param {NerdCurrencyFieldProps} props Component props
 * @returns {ReactElement} NerdCurrencyField
 */
export default function NerdCurrencyField(props) {
    const { value, onChange, textFieldProps, currencySymbol = "$", decimalCharacter = ".", digitGroupSeparator = ",", multiplier = 100, signed, normalizeZeros = false, padFractionalZeros = true, max, min, } = props;
    return (_jsx(NerdMaskField, { value: value?.toString() || "", textFieldProps: {
            InputProps: {
                startAdornment: (_jsx(InputAdornment, { position: "start", children: currencySymbol })),
            },
            inputProps: { sx: { textAlign: "right" } },
            ...textFieldProps,
        }, mask: "num", blocks: {
            num: {
                mask: Number,
                signed,
                thousandsSeparator: digitGroupSeparator,
                scale: multiplier.toFixed().length - 1,
                normalizeZeros,
                radix: decimalCharacter,
                padFractionalZeros,
                max,
                min,
            },
        }, onAccept: (_value, mask) => onChange?.(Number(mask.unmaskedValue) * multiplier) }));
}
//# sourceMappingURL=nerdCurrencyField.js.map