import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useState } from "react";
import Grid from "@mui/material/Grid";
import { ConditionalWrapper } from "../utility/conditionalWrapper";
import IconButton from "@mui/material/IconButton";
import CloseIcon from "@mui/icons-material/Close";
import { NerdDate } from "./nerdDate/nerdDate";
import { NerdText } from "./nerdText/nerdText";
import { NerdPassword } from "./nerdPassword/nerdPassword";
export const NerdInput = ({ type = "text", ...props }) => {
    const [close, setClose] = useState(false);
    const { icon, spacing = 1, disabled, fullWidth, alignItems = "center", inputSize = 6, onChange, } = props;
    const sizeWithIcons = fullWidth ? 11 : inputSize;
    const customInputSize = fullWidth && !icon ? 12 : sizeWithIcons;
    return (_jsx(ConditionalWrapper, { condition: icon !== undefined, wrapper: (childrenContent) => (_jsx(Grid, { container: true, spacing: spacing, alignItems: alignItems, children: childrenContent })), children: _jsxs(React.Fragment, { children: [icon && _jsx(Grid, { item: true, children: icon }), _jsx(Grid, { item: true, sm: customInputSize, xs: icon ? 9 : 12, children: renderNerdInputByType({ type, props, close, setClose, onChange }) }), icon && (_jsx(Grid, { item: true, children: _jsx(IconButton, { disabled: disabled, size: "small", onClick: () => setClose(true), children: _jsx(CloseIcon, {}) }) }))] }) }));
};
/**
 * @param auxProps
 * @param auxProps.type
 * @param auxProps.props
 * @param auxProps.close
 * @param auxProps.setClose
 * @param auxProps.onChange
 */
function renderNerdInputByType(auxProps) {
    const { type, props } = auxProps;
    switch (type) {
        case "date":
            return _jsx(NerdDate, { ...props });
        case "text":
            return _jsx(NerdText, { ...props });
        case "password":
            return _jsx(NerdPassword, { ...props });
        default:
            return _jsx(NerdText, { ...props });
    }
}
//# sourceMappingURL=nerdInput.js.map